Blame SOURCES/0525-01fips-Fix-creating-path-to-.hmac-of-kernel-based-on.patch

18971c
From 9b1d79993dbed054c5069f97204280a39ed61219 Mon Sep 17 00:00:00 2001
18971c
From: Lukas Nykryn <lnykryn@redhat.com>
18971c
Date: Mon, 18 Dec 2017 14:48:59 +0100
18971c
Subject: [PATCH] 01fips: Fix creating path to .hmac of kernel based on
18971c
 BOOT_IMAGE
18971c
18971c
Old code did not work for two most common use-cases.
18971c
On most machines BOOT_IMAGE is set to something like
18971c
/vmlinuz-4.11.3-202.fc25.x86_64. So if we just add prefix "/boot/."
18971c
it won't work. Also on machines without /boot on separate partition
18971c
BOOT_IMAGE already has the /boot/ prefix (/boot/vmlinuz-3.10.0-799.el7.x86_64).
18971c
So let's strip it in such case.
18971c
18971c
https://bugzilla.redhat.com/show_bug.cgi?id=1415032
18971c
18971c
Cherry-picked from: 8f5c564cb30966878b0d90025568253016e1402f
18971c
Resolves: #1415032
18971c
---
18971c
 modules.d/01fips/fips.sh | 14 ++++++++++----
18971c
 1 file changed, 10 insertions(+), 4 deletions(-)
18971c
18971c
diff --git a/modules.d/01fips/fips.sh b/modules.d/01fips/fips.sh
18971c
index ecd711c2..6c5dd60f 100755
18971c
--- a/modules.d/01fips/fips.sh
18971c
+++ b/modules.d/01fips/fips.sh
18971c
@@ -112,13 +112,19 @@ do_fips()
18971c
         do_rhevh_check /run/initramfs/live/isolinux/vmlinuz0 || return 1
18971c
     else
18971c
         BOOT_IMAGE="$(getarg BOOT_IMAGE)"
18971c
-        [ -e "/boot/.${BOOT_IMAGE}.hmac" ] || BOOT_IMAGE="vmlinuz-${KERNEL}"
18971c
+        if ! [ -e "/boot/${BOOT_IMAGE}" ]; then
18971c
+            #if /boot is not a separate partition BOOT_IMAGE might start with /boot
18971c
+            BOOT_IMAGE=${BOOT_IMAGE#"/boot"}
18971c
+            [ -e "/boot/${BOOT_IMAGE}" ] || BOOT_IMAGE="vmlinuz-${KERNEL}"
18971c
+        fi
18971c
+        
18971c
+        BOOT_IMAGE_HMAC="/boot/${BOOT_IMAGE%/*}/.${BOOT_IMAGE##*/}.hmac"
18971c
 
18971c
-        if ! [ -e "/boot/.${BOOT_IMAGE}.hmac" ]; then
18971c
-            warn "/boot/.${BOOT_IMAGE}.hmac does not exist"
18971c
+        if ! [ -e "${BOOT_IMAGE_HMAC}" ]; then
18971c
+            warn "${BOOT_IMAGE_HMAC} does not exist"
18971c
             return 1
18971c
         fi
18971c
-        sha512hmac -c "/boot/.${BOOT_IMAGE}.hmac" || return 1
18971c
+        sha512hmac -c "${BOOT_IMAGE_HMAC}" || return 1
18971c
     fi
18971c
 
18971c
     info "All initrd crypto checks done"